/*
 * The contents of this file are subject to the terms 
 * of the Common Development and Distribution License 
 * (the License).  You may not use this file except in
 * compliance with the License.
 * 
 * You can obtain a copy of the license at 
 * https://glassfish.dev.java.net/public/CDDLv1.0.html or
 * glassfish/bootstrap/legal/CDDLv1.0.txt.
 * See the License for the specific language governing 
 * permissions and limitations under the License.
 * 
 * When distributing Covered Code, include this CDDL 
 * Header Notice in each file and include the License file 
 * at glassfish/bootstrap/legal/CDDLv1.0.txt.  
 * If applicable, add the following below the CDDL Header, 
 * with the fields enclosed by brackets [] replaced by
 * you own identifying information: 
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Copyright 2006 Sun Microsystems, Inc. All rights reserved.
 */
 
/*
 * $Header: /cvs/glassfish/appserv-api/src/java/com/sun/appserv/management/util/stringifier/IteratorStringifierBase.java,v 1.1 2006/12/02 06:04:36 llc Exp $
 * $Revision: 1.1 $
 * $Date: 2006/12/02 06:04:36 $
 */
 
package com.sun.appserv.management.util.stringifier;

import java.util.Iterator;


/**
	Stringifies an Iterator, using an optional element Stringifier.
	
	Must be subclassed to provide Stringification of an element.
 */
 
public abstract class IteratorStringifierBase implements Stringifier
{
	public final String			mDelim;
	public final Stringifier	mElementStringifier;
	
		public 
	IteratorStringifierBase()
	{
		this( ObjectStringifier.DEFAULT );
	}
	
		public 
	IteratorStringifierBase( String delim )
	{
		this( delim, new SmartStringifier( delim ) );
	}
	
		public 
	IteratorStringifierBase( Stringifier elementStringifier )
	{
		this( ",", elementStringifier );
	}
	
		public 
	IteratorStringifierBase( String delim, Stringifier elementStringifier )
	{
		mDelim				= delim;
		mElementStringifier	= elementStringifier;
	}
	
		public String
	stringify( Object o )
	{
		assert( o != null );
		Iterator	iter	= (Iterator)o;
		
		return( this.stringify( iter, mDelim, mElementStringifier ) );
	}
	
	
	/*
		Subclass may choose to override this.
	 */
		protected abstract void
	stringifyElement(
		Object			elem,
		String			delim,
		StringBuffer	buf);
		
		
	
		public String
	stringify( Iterator iter, String delim, Stringifier stringifier )
	{
		assert( iter != null );
		
		StringBuffer	buf	= new StringBuffer();
	
		while ( iter.hasNext() )
		{
			final Object	elem	= iter.next();
			
			stringifyElement( elem, delim, buf );
			buf.append( delim );
		}
		
		// strip trailing delimiter
		final int	length	= buf.length();
		if ( length != 0 )
		{
			buf.setLength( length - delim.length() );
		}

		return( buf.toString() );
	}
	
	public final static IteratorStringifier DEFAULT = new IteratorStringifier( "," );
}

